//
//  TFPopView.swift
//  TalkfunSDKDemo
//
//  Created by mo2 on 2024/6/11.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TFPopView: UIView {

    var viewH:CGFloat = UIScreen.main.bounds.size.height*0.75
    
    var viewW:CGFloat = UIScreen.main.bounds.size.width
    var UIScreen_Height = UIScreen.main.bounds.size.height
    
    let view = UIButton()
    let view22 = UIButton()
    let title = UILabel()
    var PathSixe = 14.0

    var isShow:Bool = false
    


    @objc public var hideCompletion: (() -> Void)? = nil
    override init(frame: CGRect) {
        super.init(frame: frame)
     
        self.frame = CGRect(x: 0, y: 0, width: UIScreen.main.bounds.width, height: UIScreen.main.bounds.height)
        self.isHidden = true
        
        self.backgroundColor = UIColor(red: 0.11, green: 0.09, blue: 0.14, alpha: 0.5)
        self.view.backgroundColor = UIColor(red: 1, green: 1, blue: 1, alpha: 1)
        self.addSubview(self.view)
        //超出不前
        self.view.clipsToBounds = false
        self.view.backgroundColor = UIColor(red: 1, green: 1, blue: 1, alpha: 1)
        //-----------------
        view22.isHidden = true
        self.view22.backgroundColor = UIColor(red: 1, green: 1, blue: 1, alpha: 1)
        self.view.addSubview(view22)
        

    
        self.title.textAlignment = .center
        self.title.textColor = UIColor(red: 0.11, green: 0.09, blue: 0.14, alpha: 1)
        self.title.font = UIFont.PingFang(size: 16)
        self.title.frame = CGRect(x: 0, y: 0, width: UIScreen.main.bounds.size.width, height: 48.0)
        self.view.addSubview(self.title)
        
        
        
        self.showUI(false,animations: false)
        
        
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    //animations  是否动画   hideCompletion 隐藏视野成功
    func showUI(_ isShow:Bool ,animations:Bool?=nil, completion: ((Bool) -> Void)? = nil)
    {
        self.isShow = isShow
        if self.view.frame.width == 0 && isShow == false {
          
            
        }else
        {
            self.isHidden = false
        }
        if self.view.frame.width == 0 {
            let viewY:CGFloat = self.UIScreen_Height
            self.view.frame = CGRect(x: 0, y: viewY, width: UIScreen.main.bounds.size.width, height: viewH)
            
            
           
        }
        
        if(view22.isHidden == false)
        {
            view.layer.mask = nil
            view.layer.masksToBounds = false
            view.backgroundColor = .clear
        
            self.view22.frame = CGRect(x: 0, y: 0, width:  self.view.frame.width, height:viewH)
            self.view22.tf_roundedCorners(rect: self.view22.bounds, corners: [.topLeft,.topRight], cornerRadii: CGSize(width: PathSixe, height:PathSixe ))

            
        
        }else
        {
            
    
            view.tf_roundedCorners(rect: self.view.bounds, corners: [.topLeft,.topRight], cornerRadii: CGSize(width: PathSixe, height:PathSixe ))
        }
        
        self.isUserInteractionEnabled = false
        
        if self.superview != nil {
            self.superview?.addSubview(self)
        }
        
        
     
        var viewY:CGFloat = UIScreen.main.bounds.size.height-self.viewH
        if isShow == false {
            viewY = UIScreen.main.bounds.size.height
        }else
        {
            self.isHidden = false
        }

        if(animations != nil && animations == false)
        {

                self.view.frame = CGRect(x: 0, y: viewY, width: UIScreen.main.bounds.size.width, height: self.viewH)
                

                self.isUserInteractionEnabled = true

        }else
        {


            UIView.animate(withDuration: 0.5, delay: 0.0, options: UIView.AnimationOptions.allowAnimatedContent) {
                
                self.view.frame = CGRect(x: 0, y: viewY, width: UIScreen.main.bounds.size.width, height: self.viewH)
                
            } completion: { Bool in
                if isShow == false {
                    self.isHidden = true
                    if self.hideCompletion != nil {
                        self.hideCompletion!()
                      }
                    
                    
                }
                if completion != nil {
                    completion!(true)
                  }
                self.isUserInteractionEnabled = true
            }
        }
      
        
        
    }
    
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        self.showUI(false)
    }
}
