//
//  TalkfunTestPaperDetailsSubmitCell.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2021/12/20.
//  Copyright © 2021 Talkfun. All rights reserved.
//

import UIKit

class TalkfunTestPaperDetailsSubmitCell: UICollectionViewCell {
    
    @objc public let submit:UIButton = UIButton.init()
    override init(frame: CGRect) {
        super.init(frame: frame)
      
        self.backgroundColor = UIColor(red: 1, green: 1, blue: 1, alpha: 1)
        // fill
        self.submit.backgroundColor = UIColor(red: 0.25, green: 0.59, blue: 0.92, alpha: 1)
        self.submit.setTitle("交卷", for: UIControl.State.normal)
        self.submit.titleLabel?.font = UIFont(name: "PingFang SC", size: 16)
        self.addSubview(self.submit)
        
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        
        self.submit.frame = CGRect(x: 12.0, y: 10.0, width: self.frame.width - 12.0 - 12.0, height: 40.0)
        self.submit.layer.cornerRadius = 4
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
