//
//  TalkfunTestPaperDetailslSolutionCell.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/1/13.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit

class TalkfunTestPaperDetailslReplyCell: UICollectionViewCell {
    let inxLabel = UILabel()
    let content = UITextField()
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        self.contentView.addSubview(self.inxLabel)
        self.inxLabel.text = ""
        self.inxLabel.font = UIFont(name: "PingFang SC", size: 16)
        
        
        self.inxLabel.backgroundColor = UIColor.clear
        self.contentView.addSubview(self.content)
        self.content.placeholder = "请输入"
        self.layer.cornerRadius = 4
        self.layer.masksToBounds  =  true
        
        
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        self.inxLabel.frame = CGRect(x: 0, y: 0, width: 35, height: self.frame.height)
        self.content.frame = CGRect(x: self.inxLabel.frame.maxX, y: 0, width: self.frame.width - self.inxLabel.frame.maxX, height: self.frame.height)
        
    }
    required init?(coder: NSCoder) {
        
        fatalError("init(coder:) has not been implemented")
    }
}
