//
//  TF_MoreButton.swift
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2021/12/13.
//  Copyright © 2021 Talkfun. All rights reserved.
//

import UIKit

class TF_MoreButton: UIButton {

    @objc public var img:UIImageView!
    @objc public var lab:UILabel!
   
  
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.img = UIImageView.init()
        addSubview(self.img)
       
        
        self.lab = UILabel.init()
        self.lab.font = UIFont.PingFang(size: 13)
        self.lab.textColor = UIColor(red: 99/255.0, green: 104/255.0, blue: 109/255.0, alpha: 1.0)
        self.lab.textAlignment = .center
        addSubview(self.lab)
      
    }

    override func layoutSubviews() {
        super.layoutSubviews()
        self.img.frame = CGRect(x: (self.frame.size.width-36)/2.0, y: 26, width: 36, height: 36)
        self.lab.frame = CGRect(x: 0, y: self.img.frame.maxY+6, width: self.frame.size.width, height: 20)
     
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
