//
//  TFExpressionCell.swift
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2022/2/17.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit

class TFExpressionCell: UICollectionViewCell {
   @objc public var expressionImageView:UIImageView!
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.expressionImageView = UIImageView.init()
        self.contentView.addSubview(self.expressionImageView)
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        self.expressionImageView.frame = CGRect(x: (self.frame.size.width - 37)/2, y: (self.frame.size.height - 37)/2, width: 37, height: 37)
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}
