//
//  TF_LivingRollCall.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/2/21.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit

class TF_LivingRollCall: UIButton {

    
    override init(frame: CGRect) {
        super.init(frame: frame)

        self.titleLabel!.backgroundColor = UIColor(red: 0/255.0, green: 0/255.0, blue: 0/255.0, alpha: 0.5)
        

        self.titleLabel!.clipsToBounds = true
        self.titleLabel?.layer.cornerRadius = 8
        
        self.titleLabel!.font = UIFont.PingFang(size: 10)
        
   
        self.titleLabel!.textAlignment = .center;
        
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        self.imageView!.frame = CGRect(x: 0, y: 0, width: self.frame.size.width, height: 39)
        
        
        self.titleLabel!.frame = CGRect(x: 0, y: self.imageView!.frame.size.height, width: self.frame.size.width, height: self.frame.size.height - self.imageView!.frame.size.height)
        
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

}
