//
//  TF_LivingVoteScrollViewImageCell.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/2/19.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit

class TF_LivingVoteScrollViewImageCell: UITableViewCell {
    @objc public var cellWidth:CGFloat = 0
    @objc public var cellHeight:CGFloat = 0
    @objc public var imageUrlView = UIImageView()
    @objc public var model = TFOp()
 
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        self.backgroundColor = UIColor.clear
  
        self.contentView.addSubview(self.imageUrlView)
        self.imageUrlView.contentMode = .scaleAspectFit;
        
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        self.imageUrlView.frame = CGRect(x: 0, y: 0, width: self.frame.size.width, height: self.frame.size.height - 10)
        
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
