//
//  TF_LuckyBagBaseView.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/11/15.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TF_LuckyBagBaseView: UIView {
    let close = UIButton()
    
    let view = UIView()
    //顶部超级福袋的底图
    let top_basemap = UIImageView()
    var view_width:CGFloat = 342.0
    var view_hegiht:CGFloat = 288.0
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.frame = UIScreen.main.bounds
        self.backgroundColor = UIColor(red: 0, green: 0, blue: 0, alpha: 0.5)
        
        self.addSubview(view)
        view.backgroundColor = UIColor(red: 255/255, green: 245/255, blue: 232/255, alpha: 1)
        view.layer.masksToBounds = true
        view.layer.cornerRadius = 14
        
        top_basemap.contentMode = .scaleAspectFit
        top_basemap.image = UIImage(named: "超级福袋底图")
        view.addSubview(top_basemap)
        
        self.addSubview(close)
        close.setImage(UIImage(named: "daka_close"), for: .normal)
        close.backgroundColor = UIColor(red: 0, green: 0, blue: 0, alpha: 0.2)
        close.layer.masksToBounds = true
        close.addTarget(self, action: #selector(closeClick), for: .touchUpInside)
    }
    @objc func closeClick()
    {
        self.removeFromSuperview()
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        let view_x = (self.frame.width-view_width)/2
        let view_y = (self.frame.height-view_hegiht)/2
        view.frame = CGRect(x: view_x, y: view_y, width: view_width, height: view_hegiht)
        
        top_basemap.frame = CGRect(x: 0, y: 0, width: view.frame.width, height: 148)
        
        close.frame = CGRect(x: (UIScreen.main.bounds.width-40)/2, y: (self.frame.height)/2+(view_hegiht/2)+20, width: 40, height: 40)

        close.layer.cornerRadius = close.frame.height/2
    }
    

}
