//
//  TF1to16Switch.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/5/3.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit

class TF1to16Switch: UISwitch {

    @objc public let label = UILabel()
    @objc public let label1 = UILabel()

    override init(frame: CGRect) {
        super.init(frame: frame)
      
      
        self.label.numberOfLines = 0;
        self.addSubview(self.label)

        self.label.font = UIFont.PingFang(size: 16)
        self.label.textColor = UIColor(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 1)
       

        self.label1.numberOfLines = 0;
        self.addSubview(self.label1)

        self.label1.font = UIFont.PingFang(size: 16)
        self.label1.textColor = UIColor(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 1)
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        self.label.frame = CGRect(x: 3, y: 0, width: 16, height: self.frame.size.height)

        self.label1.frame = CGRect(x: self.frame.size.width-16-2, y: 0, width: 16, height: self.frame.size.height)
        
    }
}
