//
//  TFCameraViewManager.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/5/10.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit


class TFCameraViewManager: TFtouchesMoved {
    //视频窗口上的菊花
    
    
   
    @objc public let defaultDrawing1vN = UIImageView()
    @objc public  lazy var activityIndicator:UIActivityIndicatorView = {

        if #available(iOS 13.0, *) {
            let act = UIActivityIndicatorView.init(style: UIActivityIndicatorView.Style.large)

            act.isUserInteractionEnabled = false

            return act
        }else
        {
            let act = UIActivityIndicatorView.init(style: UIActivityIndicatorView.Style.whiteLarge)

            act.isUserInteractionEnabled = false

            return act
        }
       
    }()
 
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        //超出主层边框的都会被裁减调用
          //设置裁剪
        self.layer.masksToBounds =  true
        // 圆角半径  能把一个下正文体,改成圆形
        self.layer.cornerRadius = 4
        
        
        self.activityIndicator.isUserInteractionEnabled = false

        self.addSubview(self.activityIndicator)

              self.defaultDrawing1vN.isHidden = true
        
              self.defaultDrawing1vN.image = UIImage.init(named: "defaultDrawing1vN")
        self.addSubview(self.defaultDrawing1vN)
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        self.activityIndicator.frame  = self.bounds
        self.defaultDrawing1vN.frame = CGRect(x: (self.frame.size.width-144.0)/2.0, y: (self.frame.size.height-84.75)/2.0, width: 144.0, height: 84.75)
        
    }
}
