
#import "TalkfunLoginRootViewController.h"
#import "TalkfunPasswordAlertView.h"
#import "TalkfunMyCourseModel.h"

#import "TalkfunSecondNewLoginViewController.h"
#define RememberNickID @"rememberNickID1"
#define RememberID @"rememberID"
#import<SystemConfiguration/SystemConfiguration.h>
#import<netdb.h>

@interface TalkfunLoginRootViewController ()

@end

@implementation TalkfunLoginRootViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    //显示状态栏
    [[UIApplication sharedApplication] setStatusBarHidden:false];

//    UIApplication.shared.isStatusBarHidden
    self.manager = [TalkfunCourseManager shareManager];
    [self.manager createTable];
}
//所有课程列表
-(void)getinLive:(TalkfunAllCourseModel *)model
{

    NSMutableDictionary * params = [NSMutableDictionary dictionary];
    if ([model.course_id intValue] == 0) {
        if ([model.type intValue] == 4) {
            params[@"id"] = model.IDs;
        } else {
            params[@"id"] = model.roomid;
        }
       
    } else {
        params[@"id"] = model.course_id;
    }

     NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
    //uid用户的唯一标识
     params[@"uid"] = newUid;
     params[@"type"] = model.type;
     params[@"pid"] = model.pid;
    
    WeakSelf
  
    TalkfunPasswordAlertView * alert = [[TalkfunPasswordAlertView alloc]initWithTitle:@"" message:@"1" sureBtn:@"确定" cancleBtn:@"取消"];
             [alert addTarget:self action:@selector(removefromBgdBtn:) forControlEvents:UIControlEventTouchUpInside];
       __weak TalkfunPasswordAlertView * weakAlert = alert;
    alert.resultIndex = ^(NSString *string, NSString *nickStr) {
        
                 NSLog(@"string=%@,nickstr=%@",string,nickStr);

                if (nickStr.length == 0) {

                    [TalkfunLoginRootViewController TF_progressHUDShow:@"昵称不能为空"];
                  
                    return ;
                }
                 params[@"password"] = string;
                 params[@"nickname"] = nickStr;
                //设置默认渠道0
//                params[@"ctag"] = @"0";
                NSLog(@"参数param:%@",params);
        [TalkfunLoginRootViewController nav:weakSelf.navigationController viewController:self params:params callback:^(id result) {
                     NSLog(@"result:%@",result);
                     if ([result[@"code"] intValue] == 0) {
                         [weakAlert removeFromSuperview];
                         NSString * courseID = params[@"id"];
                         [UserDefault setObject:courseID forKey:RememberID];
                         NSMutableDictionary * nickDict = [NSMutableDictionary new];
                        
                         nickDict[courseID] = nickStr;
                         [UserDefault setObject:nickDict forKey:RememberNickID];
                            [UserDefault synchronize];
                        
                         
                     } else {
                         weakAlert.nosureLab.hidden = NO;
                         weakAlert.msgfield.layer.borderColor = [UIColor colorWithRed:255/255.0 green:59/255.0 blue:59/255.0 alpha:1.0].CGColor;
                         NSLog(@"密码错误");
                     }
                 }];
             };
             [alert showPasswordAlertView];
}

//防止重复添加数据库进数据库,如果有，即不添加。
+(BOOL)isEquattoModelID:(TalkfunAllCourseModel *)Allmodel andpassword:(NSString *)password
{
   NSArray * array = [[TalkfunCourseManager shareManager] selectCourseList];
    for (int i=0; i<array.count; i++) {
        TalkfunMyCourseModel * model = array[i];

        if ([model.IDs isEqualToString:Allmodel.course_id]) {
            model.password = password;
            [[TalkfunCourseManager shareManager] updateCourseModel:model];
            
            return false;
        }
    }
    
   
    return YES;
}
+(void)nav:(UINavigationController*)nav viewController:(UIViewController*)viewController  params:(NSDictionary *)params callback:(void (^)(id result))callback
{

    NSString * corseID = params[@"id"]?params[@"id"]:@"";
    [self progressHUDShow];
    
    if (@available(iOS 13.0, *)) {
        
 
    }else{
     [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
    }
    WeakSelf
    [TalkfunLoginRequest requestForNewLogin:params callback:^(id result) {

        if ([result isKindOfClass:[NSDictionary class]] &&[result[@"code"] intValue] == 0 && result[@"data"]) {
//            NSLog(@"进入课程====>%@",result);
            //直播间id
            if ([params[@"id"]isKindOfClass:[NSString class]]) {
                [UserDefault setObject:params[@"id"] forKey:RememberID];
                
                //用户名
                if ([params[@"nickname"]isKindOfClass:[NSString class]]) {
                    NSMutableDictionary * user = [NSMutableDictionary dictionary];
                    [user setObject:params[@"nickname"] forKey:params[@"id"]];
                    
                    [UserDefault setObject:user forKey:RememberNickID];
                    
                    [UserDefault synchronize];
                }
                
            }
            
            //1.0 type 判断直播or点播
            //4：房间，5：房间模式回放，9：课程（包含课程回放，回放可判断playbackUrl是否存在或为空）
            NSString * type = [TalkfunUtils getNewNumber:result[@"data"][@"type"]] ;
            NSString * playBackUrl = result[@"data"][@"playbackUrl"]?result[@"data"][@"playbackUrl"]:@"";
            NSString * access_token = result[@"data"][@"access_token"];
            
            if (access_token && ![access_token isEqualToString:@""])
            {
               
                if ([type isEqualToString:@"4"]||([type isEqualToString:@"9"] && playBackUrl.length == 0))
                {
                    
                   
                [self progressHUDDismiss];
                
                    //6是大班互动模式
                    //5小班模式
                    //3大班模式
                    NSString *modetype = [TalkfunUtils getNewNumber:result[@"data"][@"modetype"]] ;
                    //// 新增 smallType 字段，0：非小班，1：双人，2：1V6 模式，3：1V16模式
                      NSString * smallType = [TalkfunUtils getNewNumber:result[@"data"][@"smallType"]];
                    
                    /**小班自定义连麦人数 0否 1是**/
                     NSString * small_course_custom = [TalkfunUtils getNewNumber:result[@"data"][@"small_course_custom"]];
                    // 6 大班互动
                      if ([modetype isEqualToString:@"6"])
                          {

                              TFInteractLive * interactLive = [[TFInteractLive alloc]init];
                              interactLive.access_token = access_token;
                              

                              [nav pushViewController:interactLive animated:YES];
                              
                        }
                       ///5小班模式
                       else  if ([modetype isEqualToString:@"5"])
                        {
                       
                            if ([smallType isEqualToString:@"1"] && [small_course_custom isEqualToString:@"0"]) {
                                // 1v1 控制器
                                    TFLive1to1 * Live1to1 = [[TFLive1to1 alloc] init];
                                    Live1to1.access_token = access_token;
                                   [nav pushViewController:Live1to1 animated:YES];
                                    
                                    
                                }else if ([smallType isEqualToString:@"0"]) {
                                    //大班
                                    [self pushLargeLiveViewController:result nav:nav viewController:viewController];
                                
                                }
                                else{
                                    
                                TF_1vN_Live *xiaoBan = [[TF_1vN_Live alloc]init];
                                xiaoBan.access_token = access_token;
                                [nav pushViewController:xiaoBan animated:YES];
                                }
                          
                        }
                         else {
                             
                             /**直播场景：1.教育直播，2.生活直播**/
                            NSInteger scenes = [[TalkfunUtils getNewNumber:result[@"data"][@"scenes"]] integerValue];

                            if ( scenes == 2 ) {
                        
                                
                                /**pageViewMode 生活直播专用
                                 0二分屏  横屏
                                 1竖屏
                                 2课件模式
                                 3三分屏
                                 **/
                                NSInteger pageViewMode = [[TalkfunUtils getNewNumber:result[@"data"][@"pageViewMode"] ] integerValue];
                                
//                                if ([pageViewMode isEqualToString:@"1"]) {
                                   
                                    //生活直播
                                    TF_LivingController *livingController = [[TF_LivingController alloc]init];
                                      livingController.pageViewMode = pageViewMode;
                                      livingController.access_token = access_token;
                                    [nav pushViewController:livingController animated:YES];
//                                }else{
//                                    //大班
//                                    [self pushLargeLiveViewController:result nav:nav viewController:viewController];
//                                }
                                

                            }else if (scenes == 1) {
                                //大班
                                [self pushLargeLiveViewController:result nav:nav viewController:viewController];
                            }
                         
                         }

                    
                }
                else{
                   
                    
            // 获取视频类型接口
            [TalkfunLoginRequest getPlaybackType:access_token callback:^(id result1)
             {
                        [self progressHUDDismiss];
                        if ([result1 isKindOfClass:[NSDictionary class]]) {
                            
                            if ([result1[@"code"] intValue] == 0) {
                                
                                if (result1[@"data"]) {
                                    
                                    NSString *videoType = [NSString stringWithFormat:@"%@",result1[@"data"][@"videoType"]];
                                //  普通大班回放
                                    if ([videoType isEqualToString:@"1"]) {
                                
                                        [self pushLargeBackViewController:result corseID:corseID nav:nav];
    
                                    }else{
                                        //小班回放或者 大班互动回放
                                        [self pushSmallClassPlayBackController:result corseID:corseID nav:nav];
                                    
                                    }
                                }
                                
                                
                            }
                        }
                        
                    }];
                        
                 
                
                }
            }else
            {
                [self progressHUDDismiss];
           
                
                [TalkfunLoginRootViewController TF_progressHUDShow:@"access_token数据为空"];
            }
          //----------
            dispatch_async(dispatch_get_main_queue(), ^{
               NSDictionary *data = result[@"data"];
                TalkfunMyCourseModel * mymodel = [[TalkfunMyCourseModel alloc]init];
                
                mymodel.roomID = corseID;
                mymodel.IDs = corseID;
                mymodel.account = corseID;
                
                mymodel.nickname = params[@"nickname"]?params[@"nickname"]:@"";
                mymodel.password = params[@"password"]?params[@"password"]:@"";
                mymodel.title  = data[@"title"]?data[@"title"]:@"";
                mymodel.type =  data[@"type"]?data[@"type"]:@"";
                mymodel.listKey = data[@"listKey"]?data[@"listKey"]:@"";
                mymodel.access_token = data[@"access_token"]?data[@"access_token"]:@"";
                mymodel.start_time = @"";
                mymodel.status = @"";
                TalkfunAllCourseModel *model = [[TalkfunAllCourseModel alloc]init];
                model.course_id = corseID;
                 BOOL isRepeatID = [weakSelf isEquattoModelID:model andpassword:mymodel.password];
                if (isRepeatID) {
                    
                    [[TalkfunCourseManager shareManager] addCourseModel:mymodel];


                } else {
                    
                }
            

          });
            
            
        }else{

                [self progressHUDDismiss];
                //密码更改之后，删除保存的数据
                [UserDefault removeObjectForKey:corseID];
            NSString *newMsg = @"";
            if ([result isKindOfClass:[NSDictionary class]]) {

                NSString *msg = @"密码错误";
                if(result[@"msg"])
                {
                    msg = result[@"msg"];
                }
                newMsg = msg;
         
            }else{
                NSError * error = result;
                newMsg = error.userInfo[NSLocalizedDescriptionKey];
              
            }
            [TalkfunLoginRootViewController TF_progressHUDShow:newMsg];

        }

           if (callback) {
                callback(result);
            }


    }];

}


+ (void)pushLargeLiveViewController:(NSDictionary*)result nav:(UINavigationController*)nav viewController:(UIViewController*)viewController
{
    [self pushLargeLive:result[@"data"][@"access_token"] title:result[@"title"] ?result[@"title"] :@"" nav:nav viewController:viewController];
}
+ (void)pushLargeLive:(NSString*)access_token title:(NSString*)title nav:(UINavigationController*)nav viewController:(UIViewController*)viewController

{
    TFLargeLive *myVC = [[TFLargeLive alloc] init];
    myVC.access_token = access_token;
    myVC.title = title;
    if (nav) {
        [nav pushViewController:myVC animated:YES];
    }else
    {
        myVC.modalPresentationStyle = UIModalPresentationFullScreen;
        [viewController presentViewController:myVC animated:YES completion:nil];

    }
 
}
+ (void)pushLargeBackViewController:(NSDictionary*)result corseID:(NSString*)corseID nav:(UINavigationController*)nav
{
    if (result[@"data"]) {
        
        NSDictionary * data = result[@"data"];
        
        [self pushLargeBackView:corseID access_token:data[@"access_token"]?data[@"access_token"]:@"" logo:data[@"logo"]?data[@"logo"]:@"" title:data[@"title"]?data[@"title"]:@"" nav:nav];
        
    }

}
+ (void)pushLargeBackView:(NSString*)playbackID access_token:(NSString*)access_token  logo:(NSString*)logo title:(NSString*)title nav:(UINavigationController*)nav

{
    TalkfunViewLargeBack *playbackVC = [[TalkfunViewLargeBack alloc] init];
    playbackVC.playbackID = playbackID;
    
    playbackVC.access_token = access_token?access_token:@"";
    
    playbackVC.logo = logo?logo:@"";
    
    playbackVC.courseName = title?title:@"";
    [nav pushViewController:playbackVC animated:YES];
}

+ (void)pushSmallClassPlayBackController:(NSDictionary*)result corseID:(NSString*)corseID nav:(UINavigationController*)nav
{
    NSMutableDictionary *parameters = [NSMutableDictionary dictionaryWithDictionary:result];
    parameters[TalkfunPlaybackID] = corseID;
    TF_SmallClassPlayBackController *playbackVC = [[TF_SmallClassPlayBackController alloc] init];
    playbackVC.playbackID = corseID;
    if (parameters[@"data"]) {
        playbackVC.access_token = parameters[@"data"][@"access_token"];
    }
    [nav pushViewController:playbackVC animated:YES];
}

+ (void)TF_progressHUDShow:(NSString*)msg
{
    [SVProgressHUD setImageViewSize:CGSizeMake(0, 0)];
    [SVProgressHUD showImage:[UIImage imageNamed:@""] status:msg];

    [SVProgressHUD setDefaultMaskType:SVProgressHUDMaskTypeBlack];
    [SVProgressHUD dismissWithDelay:0.5];
    
}
+ (void)progressHUDShow
{
    //不是扫码的登陆
   if ([self connectedToNetwork]) {
       [SVProgressHUD setDefaultStyle:SVProgressHUDStyleDark];
       [SVProgressHUD setDefaultMaskType:SVProgressHUDMaskTypeClear];
       [SVProgressHUD show];
   }
    
}
+ (void)progressHUDDismiss
{
    if ([self connectedToNetwork]) {
        [SVProgressHUD dismiss];
    }
}

-(void)removefromBgdBtn:(UIButton *)btn
{
    [btn removeFromSuperview];
}

#pragma mark - 拿本地存储的数据
- (id)getNSUserDefaultWithKey:(NSString *)key{
    
    id obj = [[NSUserDefaults standardUserDefaults] objectForKey:key];
    return obj;
}

- (CGRect)getMainScreenBounds
{
    
    CGFloat superViewW = [UIScreen mainScreen].bounds.size.width;
    CGFloat superViewH = [UIScreen mainScreen].bounds.size.height;
        
    //1 ==螢幕直立

    if (superViewH< superViewW) {
        //[UIDevice currentDevice].orientation==1 &&
            superViewH =  [UIScreen mainScreen].bounds.size.width;
            superViewW =  [UIScreen mainScreen].bounds.size.height ;
    }
    
    return CGRectMake(0, 0, superViewW, superViewH);
}
-(UIImageView *)noLiveImgview
{
    if (!_noLiveImgview) {
        _noLiveImgview = [[UIImageView alloc]init];
        _noLiveImgview.frame = CGRectMake(([self getMainScreenBounds].size.width-132)/2.0, self.view.frame.size.height/3.0-40, 132, 84);
        _noLiveImgview.image = [UIImage imageNamed:@"nolive"];
    
        
    }
    return _noLiveImgview;
}

-(UILabel *)noliveLab
{
    if (!_noliveLab) {
        _noliveLab = [[UILabel alloc]init];
        _noliveLab.frame = CGRectMake(([self getMainScreenBounds].size.width-80)/2.0, CGRectGetMaxY(self.noLiveImgview.frame)+16, 80, 24);
        _noliveLab.font = [UIFont fontWithName:@"PingFang SC" size: 17];
        _noliveLab.textColor = [UIColor colorWithRed:110/255.0 green:112/255.0 blue:114/255.0 alpha:1.0];
        _noliveLab.text = @"暂无直播";
    }
    return _noliveLab;
}

-(UIButton *)joinLive
{
    if (!_joinLive) {
        _joinLive = [UIButton buttonWithType:UIButtonTypeCustom];
        _joinLive.frame = CGRectMake(([self getMainScreenBounds].size.width-125)/2.0, CGRectGetMaxY(self.noliveLab.frame)+20, 125, 44);
        [_joinLive setTitle:@"进入直播" forState:UIControlStateNormal];
        [_joinLive setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _joinLive.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
        _joinLive.layer.shadowColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:0.30].CGColor;
        _joinLive.layer.shadowOffset = CGSizeMake(0,2.5);
        _joinLive.layer.shadowRadius = 5;
        _joinLive.layer.shadowOpacity = 1;
        _joinLive.layer.cornerRadius = 22;
        [_joinLive addTarget:self action:@selector(addBtnClick) forControlEvents:UIControlEventTouchUpInside];
    }
    return _joinLive;
}

-(void)addBtnClick
{
    TalkfunSecondNewLoginViewController * vc = [[TalkfunSecondNewLoginViewController alloc]init];
    vc.hidesBottomBarWhenPushed = YES;
    
    [self.navigationController pushViewController:vc animated:YES];
}

+ (BOOL)connectedToNetwork{
   
    //创建零地址，0.0.0.0的地址表示查询本机的网络连接状态
   
    struct sockaddr_storage zeroAddress;
   
    bzero(&zeroAddress, sizeof(zeroAddress));
    zeroAddress.ss_len = sizeof(zeroAddress);
    zeroAddress.ss_family = AF_INET;
   
    // Recover reachability flags
    SCNetworkReachabilityRef defaultRouteReachability = SCNetworkReachabilityCreateWithAddress(NULL, (struct sockaddr *)&zeroAddress);
    SCNetworkReachabilityFlags flags;
   
    //获得连接的标志
    BOOL didRetrieveFlags = SCNetworkReachabilityGetFlags(defaultRouteReachability, &flags);
    CFRelease(defaultRouteReachability);
   
    //如果不能获取连接标志，则不能连接网络，直接返回
    if (!didRetrieveFlags)
    {
        return NO;
    }
    //根据获得的连接标志进行判断
   
    BOOL isReachable = flags & kSCNetworkFlagsReachable;
    BOOL needsConnection = flags & kSCNetworkFlagsConnectionRequired;
    return (isReachable&&!needsConnection) ? YES : NO;
}
- (BOOL)prefersStatusBarHidden {
    return false;
}
@end
