//
//  TalkfunPasswordAlertView.h
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2020/7/28.
//  Copyright © 2020 Talkfun. All rights reserved.
//

#import <UIKit/UIKit.h>
@protocol TalkfunPasswordAlertViewDelegate <NSObject>
@optional
- (void)Index:(NSString*)string nickStr:(NSString*)nickStr;
@end
typedef void(^PasswordResult)(NSString* string,NSString * nickStr);

@interface TalkfunPasswordAlertView : UIButton

@property(nonatomic,strong)UILabel * nosureLab;

@property(nonatomic,strong)UITextField * msgfield;

@property(nonatomic,strong)UITextField * NickNamefield;

@property(nonatomic,copy)PasswordResult resultIndex;


@property (nonatomic, weak) id<TalkfunPasswordAlertViewDelegate> delegate;
-(instancetype)initWithTitle:(NSString*)title message:(NSString *)message sureBtn:(NSString *)sureTitle cancleBtn:(NSString *)cancleTitle;

-(void)showPasswordAlertView;
@end

