//
//  TFTouchBlockView.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/5/6.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit
typealias touchesBeganBlock = () -> Void
class TFTouchBlockView: UIView {

    @objc public var touchesBegan:touchesBeganBlock?
    
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        
        if self.touchesBegan != nil {
            self.touchesBegan!()
        }
        self.endEditing(true)
        
        NotificationCenter.default.post(name: Notification.Name(rawValue: "keyboardWillHide"), object: nil)
        
       
    }

}
