//
//  TFLargeLivePPTview.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/4/26.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit

class TFLargeLivePPTview: UIView {

    /**暖场视频*/
    let warmupContainerView = UIView()
    //课程未开始前的处理
    let courseStatus = TFCourseStatusView()
    //ppt信息及按钮
    let pptsFunctionView = TFPPTFunctionView()
    
    @objc public var touchesBegan:touchesBeganBlock?
    override init(frame: CGRect) {
        super.init(frame: frame)
        warmupContainerView.isHidden = true
        self.addSubview(warmupContainerView)
        
        
        self.addSubview(courseStatus)

        
        self.addSubview(self.pptsFunctionView)
    }
   
    override func layoutSubviews() {
        super.layoutSubviews()
        
        courseStatus.frame = CGRect(x: 0, y: (self.frame.height-courseStatus.viewH)/2, width: self.frame.size.width, height: courseStatus.viewH)
        
        self.warmupContainerView.frame = self.bounds
        
        self.pptsFunctionView.frame = self.bounds
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
    
        if self.touchesBegan != nil {
            self.touchesBegan!()
        }
    }
}
