//
//  TF_ReportView.swift
//  TalkfunSDKDemo
//
//  Created by mo2 on 2024/6/11.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TF_ReportView: TFPopView {
    //举报的窗口
    public let report = TF_LiveReportView()
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        self.viewH = 338.5
        //TODO:举报
        self.report.addTarget(self, action: #selector(self.selectionClick), for: .touchUpInside)

        self.view.addSubview(self.report)
        self.report.backgroundColor = UIColor(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 1)
        
        
    }
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        self.endEditing(true)
        self.showUI(false)
    }
    @objc func selectionClick()
    {
       
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        
        self.report.frame = CGRect(x: 0, y: 0, width: self.viewW, height: self.viewH)
        self.report.initMask()
    }

}
class TF_LiveReportView: TF_LivingReportView
{
    /*
     监听键盘的即将显示
     */
    @objc override func keyboardWillShow(noti:NSNotification)
    {
    
        self.isShowReport = true

           //不是聊天不用处理
        if (self.currentTextView(self.textView) == true) {
                
            }else{
                
                return;
                
            }
        let keyboardInfo:NSDictionary = noti.userInfo! as NSDictionary
        
        let keyboardFrameEnd:NSValue = keyboardInfo.value(forKey: UIResponder.keyboardFrameEndUserInfoKey) as! NSValue
        
        let frame:CGRect = keyboardFrameEnd.cgRectValue
        self.KeyboardHeight = frame.size.height;
        // 修改底部约束
         let  chatBarY:CGFloat = TalkfunSharedTools.getMainScreen().size.height - frame.size.height - self.frame.size.height
    
         let animationDuration:NSNumber = keyboardInfo.value(forKey: UIResponder.keyboardAnimationDurationUserInfoKey) as! NSNumber
         //  执行动画
         let duration = animationDuration.floatValue
        UIView.animate(withDuration: TimeInterval(duration)) {
          if let superview2 = self.superview
            {
                superview2.frame = CGRect(x: 0, y: chatBarY, width:  self.frame.size.width, height: self.frame.size.height)
            }
           
        }

        
    }
    /**
     *  监听键盘的即将隐藏
     */
    @objc override func KeyboardWillHide(noti:NSNotification)
    {
        if self.isShowReport {
            self.isShowReport = false

           
            if (self.currentTextView(self.textView) == true) {
                
                let keyboardInfo:NSDictionary = noti.userInfo! as NSDictionary
                
                let animationDuration:NSNumber = keyboardInfo.value(forKey: UIResponder.keyboardAnimationDurationUserInfoKey) as! NSNumber
                //  执行动画
                let duration = animationDuration.floatValue
                
            
                let  chatBarY:CGFloat = TalkfunSharedTools.getMainScreen().size.height - self.frame.size.height;
                
                UIView.animate(withDuration: TimeInterval(duration)) {
                    if let superview2 = self.superview
                    {
                        superview2.frame = CGRect(x: 0, y: chatBarY, width:  self.frame.size.width, height: self.frame.size.height)
                    }
                    
                }
            
        }
        }
  
}
}
