//
//  TF_viewThePrize.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/11/20.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TF_viewThePrize: UIButton {
    //当前福袋id
    var currentID:NSInteger = 0
    
    enum TF_viewThePrizeType {
        case check  /*查看中奖*/
        case receive /*领取奖品*/
       
    }
    // 使用
    var type = TF_viewThePrizeType.check
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        self.setImage(UIImage(named: "查看福袋"), for: .normal)
        self.setImage(UIImage(named: "查看福袋"), for: .highlighted)
        self.setAttributedTitle(NSAttributedString.getAttributed(string: "查看中奖", font: UIFont.PingFang(size: 12), foregroundColor: UIColor(red: 255/255, green: 255/255, blue: 255/255, alpha: 1)), for: .normal)
        
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
    }
    func addToViwe(view:UIView,type:TF_viewThePrizeType)
    {
        self.type = type
        
        if type == .check {
            self.setAttributedTitle(NSAttributedString.getAttributed(string: "查看中奖", font: UIFont.PingFang(size: 12), foregroundColor: UIColor(red: 255/255, green: 255/255, blue: 255/255, alpha: 1)), for: .normal)
        }else if type == .receive{
            
            self.setAttributedTitle(NSAttributedString.getAttributed(string: "领取奖品", font: UIFont.PingFang(size: 12), foregroundColor: UIColor(red: 255/255, green: 255/255, blue: 255/255, alpha: 1)), for: .normal)
        }
        
        view.addSubview(self)
        
        
    }
    
}
