//
//  TFVideoGralleryCell.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/5/7.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit

class TFVideoGralleryCell: UICollectionViewCell {
    @objc public let backImgView = UIView()
    @objc public let imgView = UIImageView()

    override init(frame: CGRect) {
        super.init(frame: frame)
        
        
        self.backgroundColor = UIColor(red: 28/255.0, green: 31/255.0, blue: 35/255.0, alpha: 1)
        self.contentView.addSubview(self.backImgView)
        
        
        self.imgView.image = UIImage.init(named: "学员")
        self.backImgView.addSubview(self.imgView)
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        
        self.backImgView.frame = self.bounds
        
        self.imgView.frame = CGRect(x: (self.backImgView.frame.size.width-65)/2.0, y: (self.backImgView.frame.size.height-65)/2.0, width: 65, height: 65)
    }
    
}
