//
//  TalkfunScanNewLoginViewController.m
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2020/7/20.
//  Copyright © 2020 Talkfun. All rights reserved.
//

#import "TalkfunScanNewLoginViewController.h"
#import "UIImageView+WebCache.h"

#import "TalkfunCourseManager.h"
#import "TalkfunMyCourseModel.h"

#define kWidth  [TalkfunUtils getMainScreen].size.width
#define kHeight [TalkfunUtils getMainScreen].size.height
#define RememberNickID @"rememberNickID1"
#define LogoUrl @"LogoUrl2"
#define KIsiPhoneX  @available(iOS 11.0, *) && UIApplication.sharedApplication.keyWindow.safeAreaInsets.bottom > 0.0
@interface TalkfunScanNewLoginViewController ()<UITextFieldDelegate>
@property(nonatomic,strong)UIImageView * logoImg;  //公司图片
@property(nonatomic,strong)UIButton * joinCourseBtn; //进入课程

@property(nonatomic,strong)UILabel * VersionLab;

@property(nonatomic,strong)UITextField * idTF;//id

@property(nonatomic,strong)UITextField * passwordTF; //密码

@property(nonatomic,strong)UIView * tfView1;

@property(nonatomic,strong)UIView * tfView2;

@property(nonatomic,strong)CAReplicatorLayer *repLicatorLayer;

@property(nonatomic,copy)NSString * idStr;
@end

@implementation TalkfunScanNewLoginViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    if (@available(iOS 13.0, *)) {
        
 
    }else{
    [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
    }
         //强制翻转屏幕，Home键在右边。
              [[UIDevice currentDevice] setValue:@(UIInterfaceOrientationLandscapeRight) forKey:@"orientation"];
         [[UIDevice currentDevice] setValue:@(UIInterfaceOrientationPortrait) forKey:@"orientation"];

       [self creatUI];
    if (self.roomid||self.liveid) {
          self.idStr = self.roomid?self.roomid:self.liveid;
    }
    
    if (self.nickName) {
        self.passwordTF.text = self.nickName;
    }
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillShow:) name:UIKeyboardWillShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillHide:) name:UIKeyboardWillHideNotification object:nil];
    self.manager = [TalkfunCourseManager shareManager];
    [self.manager createTable];
    
    NSLog(@"idstr:%@",self.idStr);
}
-(void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}
-(void)creatUI
{
    
    CGFloat SafetyZone = 0;
      if (KIsiPhoneX) {
        SafetyZone = 24;
        }

    UIView * bgview = [[UIView alloc]init];
    bgview.frame = CGRectMake(0, 0, kWidth, 64+SafetyZone);
    bgview.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
    [self.view addSubview:bgview];

    UIButton * backBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateSelected];
    [backBtn addTarget:self action:@selector(backBtnClick) forControlEvents:UIControlEventTouchUpInside];
    backBtn.frame = CGRectMake(0, 24+SafetyZone, 40, 40);
    [bgview addSubview:backBtn];

    UILabel * titleLab = [[UILabel alloc]init];
    titleLab.text = @"进入课程";
    titleLab.frame = CGRectMake((kWidth-90)/2,29.5+SafetyZone,90,25);
    titleLab.numberOfLines = 0;
    titleLab.textColor = [UIColor whiteColor];
    titleLab.textAlignment = NSTextAlignmentCenter;
    titleLab.font = [UIFont fontWithName:@"PingFang SC" size: 18];
    [self.view addSubview:titleLab];
    
    self.logoImg.frame = CGRectMake((kWidth-144)/2.0, 149, 144, 35);
    self.tfView1.frame = CGRectMake(20, CGRectGetMaxY(self.logoImg.frame)+30.5, kWidth-40, 44);
    UIImageView * tvImg = [[UIImageView alloc]init];
    tvImg.image = [UIImage imageNamed:@"password"];
    [self.tfView1 addSubview:tvImg];
    self.tfView2.frame = CGRectMake(20, CGRectGetMaxY(self.tfView1.frame)+20, kWidth-40, 44);
    UIImageView * passwordImg = [[UIImageView alloc]init];
    passwordImg.image = [UIImage imageNamed:@"昵称"];
    [self.tfView2 addSubview:passwordImg];
      if (kWidth == 320) {
          tvImg.frame = CGRectMake(12, 10, 22, 22);
          self.idTF.frame = CGRectMake(CGRectGetMaxX(tvImg.frame)+10, 7, CGRectGetWidth(self.tfView1.frame)-44-13, 30);
           passwordImg.frame = CGRectMake(12, 10, 22, 22);
           self.passwordTF.frame = CGRectMake(CGRectGetMaxX(passwordImg.frame)+10, 7, CGRectGetWidth(self.tfView1.frame)-44-13, 30);
      } else {
          tvImg.frame = CGRectMake(22, 10, 22, 22);
          self.idTF.frame = CGRectMake(CGRectGetMaxX(tvImg.frame)+17.5, 7, CGRectGetWidth(self.tfView1.frame)-61.5-13, 30);
           passwordImg.frame = CGRectMake(22, 10, 22, 22);
           self.passwordTF.frame = CGRectMake(CGRectGetMaxX(passwordImg.frame)+17.5, 7, CGRectGetWidth(self.tfView1.frame)-61.5-13, 30);
      }

    UIButton * idtfDeletBtn = [self.idTF valueForKey:@"_clearButton"];
    [idtfDeletBtn setImage:[UIImage imageNamed:@"logln_delete"] forState:UIControlStateNormal];
    
    UIButton *passwordDeletBtn = [self.passwordTF valueForKey:@"_clearButton"];
    [passwordDeletBtn setImage:[UIImage imageNamed:@"logln_delete"] forState:UIControlStateNormal];
    
    self.joinCourseBtn.frame = CGRectMake(20, CGRectGetMaxY(self.tfView2.frame)+60, CGRectGetWidth(self.tfView2.frame), 50);
    
     self.VersionLab.frame = CGRectMake((kWidth-200)/2.0, kHeight-24-22.5, 200, 22.5);
    
}
-(void)backBtnClick
{
    [self removeFromParentViewController:@"TalkfunScanViewController"];
    [self poptoViewController:@"TalkfunSecondNewLoginViewController"];

}

- (void)removeFromParentViewController:(NSString*)name
{
    if (self.navigationController) {
        NSArray* tempVCA = [self.navigationController viewControllers];

        for(UIViewController *tempVC in tempVCA)
        {
            if([NSStringFromClass([tempVC class]) isEqualToString:name?name:@""])
            {
                [tempVC removeFromParentViewController];
                
            }
        }
    }

}

-(void)poptoViewController:(NSString *)name
{
    if (self.navigationController) {
        NSArray* tempVCA = [self.navigationController viewControllers];

        for(UIViewController *tempVC in tempVCA)
        {
            if([NSStringFromClass([tempVC class]) isEqualToString:name?name:@""])
            {
               
                [self.navigationController popToViewController:tempVC animated:YES];
            }
        }
    }
}


//加载动画
-(void)tranStateAnimation
{
     self.repLicatorLayer = [CAReplicatorLayer layer];
     self.repLicatorLayer.bounds = CGRectMake(0, 0, 100, 100);
     self.repLicatorLayer.cornerRadius = 10.0;
     self.repLicatorLayer.position = self.view.center;
     self.repLicatorLayer.backgroundColor = [UIColor whiteColor].CGColor;
     self.repLicatorLayer.instanceCount = 3;
     self.repLicatorLayer.instanceTransform = CATransform3DMakeTranslation(self.repLicatorLayer.frame.size.width/3, 0, 0);
     self.repLicatorLayer.instanceDelay = 1.0/3;
     [self.view.layer addSublayer:self.repLicatorLayer];
     
     CALayer * dotLayer = [CALayer layer];
     dotLayer.bounds = CGRectMake(0, 0, 15, 15);
     dotLayer.position = CGPointMake(15, self.repLicatorLayer.frame.size.height/2);
     dotLayer.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:0.6].CGColor;
     dotLayer.cornerRadius    = 7.5;
     dotLayer.transform = CATransform3DMakeScale(0, 0, 0);
     [self.repLicatorLayer addSublayer:dotLayer];
     
     CABasicAnimation *animation = [CABasicAnimation animationWithKeyPath:@"transform.scale"];
     animation.duration    = 1.0;
     animation.fromValue   = @1;
     animation.toValue     = @0;
     animation.repeatCount = MAXFLOAT;
     [dotLayer addAnimation:animation forKey:nil];
    
   
    
}

-(NSString*)getNumber:(NSObject*)obj
{
    NSString *UsersXid = @"0";
    
    if([obj isKindOfClass:[NSNumber class] ]){
        
        NSNumber  *num     = (NSNumber*) obj;
        NSNumberFormatter *tempNum = [[NSNumberFormatter alloc] init];
        
        UsersXid = [tempNum stringFromNumber:num];
    }else if([obj isKindOfClass:[NSString class] ]){
        
        NSString  *str    = (NSString*)obj;
        UsersXid = str;
    }
    
    return UsersXid;
}

//防止重复添加数据库进数据库,如果有，即不添加。
-(BOOL)isEquattoModelID:(NSString *)idstr
{
   NSArray * array = [self.manager selectCourseList];
     
    for (TalkfunMyCourseModel * model in array) {
        
        if ([model.IDs isEqualToString:idstr]) {
            model.password = self.idTF.text;
            [self.manager updateCourseModel:model];
            return NO;

        }
    }
  
    return YES;
}
//扫码结果 
- (void)getInBtnClicked:(UIButton *)sender {
    
      [self.view endEditing:YES];
      if (TEXTFIELDHASNOVALUE(self.passwordTF)) {
           [TalkfunLoginRootViewController TF_progressHUDShow:@"昵称不能为空"];
           return;
      }

    NSMutableDictionary * params = [NSMutableDictionary new];
    params[@"id"] = self.idStr;
    //uid用户的唯一标识
    NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
    newUid = [newUid stringByAppendingString:[self getCurrentDateString]];
    
    params[@"uid"] = newUid;
    params[@"type"] = self.type;
    params[@"password"] = self.idTF.text;
    //设置渠道
    if (self.ctag&&self.ctag.length>0) {
     params[@"ctag"] = self.ctag;
    }
    if (!TEXTFIELDHASNOVALUE(self.passwordTF)) {
     params[@"nickname"] = self.passwordTF.text;
    }
   
    [TalkfunLoginRootViewController nav:self.navigationController viewController:self params:params callback:^(id  _Nonnull result) {
        
    }];

}
//获取当前时间戳

-(NSString *)getCurrentDateString
{
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init] ;
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    [formatter setDateFormat:@"YYYY-MM-dd HH:mm:ss"]; // ----------设置你想要的格式,hh与HH的区别:分别表示12小时制,24小时制
    //设置时区,这个对于时间的处理有时很重要
    NSTimeZone* timeZone = [NSTimeZone timeZoneWithName:@"Asia/Shanghai"];
    [formatter setTimeZone:timeZone];
    NSDate *datenow = [NSDate date];//现在时间,你可以输出来看下是什么格式
    NSString *timeSp = [NSString stringWithFormat:@"%ld", (long)[datenow timeIntervalSince1970]];
    return timeSp;
}
- (void)aboutBtnClicked
{

}
- (void)keyboardWillShow:(NSNotification *)notification{
    [UIView animateWithDuration:0.25 animations:^{
        for (UIView * view in self.view.subviews) {
            view.transform = CGAffineTransformMakeTranslation(0, -44);
        }
      
    }];
}

- (void)keyboardWillHide:(NSNotification *)notification{
    [UIView animateWithDuration:0.25 animations:^{
        for (UIView * view in self.view.subviews) {
            view.transform = CGAffineTransformIdentity;;
        }
    }];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
      self.navigationController.navigationBar.barStyle = UIBarStyleBlack;
        [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
      
      [self logoImageSet];
    
}



-(void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    self.navigationController.navigationBar.hidden = YES;
    self.view.userInteractionEnabled = YES;
}

#pragma mark - textfield delegate
- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField{
    if (textField == self.idTF) {
         self.tfView1.layer.borderColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0].CGColor;
        self.tfView2.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
      
    }else if (textField == self.passwordTF){

        self.tfView2.layer.borderColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0].CGColor;
        self.tfView1.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;

    }
    return YES;
}


-(UIImageView *)logoImg
{
    if (!_logoImg) {
        _logoImg = [[UIImageView alloc]init];
        _logoImg.image = [UIImage imageNamed:@"欢拓logo"];
        [self.view addSubview:_logoImg];
    }
    return _logoImg;
}

//获取logo图片
- (void)logoImageSet{
    id obj = [UserDefault objectForKey:LogoUrl];
  
    NSString * logoUrl = obj[@"log"]?obj[@"logo"]:@"";
    if (logoUrl.length > 0) {
        NSString * logoUrl = obj[@"logo"];
        [self.logoImg sd_setImageWithURL:[NSURL URLWithString:logoUrl] placeholderImage:nil options:0];
        
    }else{
        self.logoImg.image = [UIImage imageNamed:@"欢拓logo"];
    }
}

-(UIView *)tfView1
{
    if (!_tfView1) {
        _tfView1 = [[UIView alloc]init];
        _tfView1.alpha = 1.0;
        _tfView1.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
        _tfView1.layer.borderWidth = 0.5;
        _tfView1.layer.cornerRadius = 22;
        [self.view addSubview:_tfView1];
    }
    return _tfView1;
}

-(UIView *)tfView2
{
    if (!_tfView2) {
           _tfView2 = [[UIView alloc]init];
           _tfView2.alpha = 1.0;
           _tfView2.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
           _tfView2.layer.borderWidth = 0.5;
           _tfView2.layer.cornerRadius = 22;
        [self.view addSubview:_tfView2];
       }
       return _tfView2;
}

-(UITextField *)idTF
{
    if (!_idTF) {
        _idTF = [[UITextField alloc]init];
      
        _idTF.font = [UIFont fontWithName:@"PingFang SC" size:16];
         _idTF.placeholder = @"若是公开课，无需密码";
        _idTF.delegate = self;
        _idTF.keyboardType = UIKeyboardTypeDefault;
        _idTF.clearButtonMode = UITextFieldViewModeWhileEditing;
        [self.tfView1 addSubview:_idTF];
    }
    return _idTF;
}


-(UITextField *)passwordTF
{
    if (!_passwordTF) {
        _passwordTF = [[UITextField alloc]init];
       _passwordTF.delegate = self;
       _passwordTF.font = [UIFont fontWithName:@"PingFang SC" size:16];
       _passwordTF.placeholder = @"请输入昵称";
       _passwordTF.secureTextEntry = NO;
        _passwordTF.clearButtonMode = UITextFieldViewModeWhileEditing;
      [self.tfView2 addSubview:_passwordTF];
             
    }
    
    return _passwordTF;
  
}

-(UIButton *)joinCourseBtn
{
    if (!_joinCourseBtn) {
        _joinCourseBtn = [UIButton buttonWithType:UIButtonTypeCustom];
   
        _joinCourseBtn.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
        _joinCourseBtn.layer.shadowColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:0.30].CGColor;
        _joinCourseBtn.layer.shadowOffset = CGSizeMake(0,2.5);
         _joinCourseBtn.layer.shadowRadius = 5;
       _joinCourseBtn.layer.shadowOpacity = 1;
       _joinCourseBtn.layer.cornerRadius = 25;
      [_joinCourseBtn setTitle:@"进入课程" forState:UIControlStateNormal];
    [_joinCourseBtn addTarget:self action:@selector(getInBtnClicked:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_joinCourseBtn];
          
    }
    
    return _joinCourseBtn;
}

-(UILabel *)VersionLab
{
    if (!_VersionLab) {
        _VersionLab = [[UILabel alloc]init];
        
        _VersionLab.text = [self GetVersionText];
        _VersionLab.font = [UIFont fontWithName:@"PingFang SC" size:16];
        _VersionLab.textColor = [UIColor colorWithRed:73/255.0 green:150/255.0 blue:217/255.0 alpha:1.0];
        _VersionLab.textAlignment = NSTextAlignmentCenter;
        UITapGestureRecognizer * versionTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(aboutBtnClicked)];
        _VersionLab.userInteractionEnabled = YES;
        [_VersionLab addGestureRecognizer:versionTap];
        [self.view addSubview:_VersionLab];
    }
    return _VersionLab;
}
- (NSString*)GetVersionText{
    NSString * version = [[NSBundle mainBundle] infoDictionary][@"CFBundleShortVersionString"];
    NSString * str = [NSString stringWithFormat:@"欢云播 v %@",version];
    return str;
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
    [self.view endEditing:YES];
}
#pragma mark - 旋转
- (BOOL)shouldAutorotate{
    //强制翻转屏幕，Home键在右边。
    [[UIDevice currentDevice] setValue:@(UIDeviceOrientationPortrait) forKey:@"orientation"];
    return YES;
}
-(UIInterfaceOrientationMask)supportedInterfaceOrientations
{
   
    return UIInterfaceOrientationMaskPortrait;
}

- (UIStatusBarStyle)preferredStatusBarStyle{
    return UIStatusBarStyleLightContent;//白色
}
-(void)dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

@end
