//
//  TalkfunLoginRootViewController.h
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2022/2/14.
//  Copyright © 2022 Talkfun. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "TalkfunAllCourseModel.h"
#import "TalkfunCourseManager.h"
#define TEXTFIELDHASNOVALUE(obj) (obj == nil || obj.text == nil || obj.text.length == 0)
NS_ASSUME_NONNULL_BEGIN

@interface TalkfunLoginRootViewController : UIViewController
//@property(nonatomic,copy) NSString * uid;  //uuid
@property(nonatomic,copy)NSString *listKey; //获取直播/课程列表的key
@property(nonatomic,strong)UIImageView * noLiveImgview;
@property(nonatomic,strong)UILabel * noliveLab;
@property(nonatomic,strong)UIButton * joinLive; //进入直播
@property(nonatomic,strong)TalkfunCourseManager * manager;  // 管理对象
-(void)getinLive:(TalkfunAllCourseModel *)model;

+(void)nav:(UINavigationController*)nav viewController:(UIViewController*)viewController  params:(NSDictionary *)params callback:(void (^)(id result))callback;

- (CGRect)getMainScreenBounds;

+ (void)pushLargeBackView:(NSString*)playbackID access_token:(NSString*)access_token  logo:(NSString*)logo title:(NSString*)title nav:(UINavigationController*)nav;

+ (void)pushLargeLive:(NSString*)access_token title:(NSString*)title nav:(UINavigationController*)nav viewController:(UIViewController*)viewController;

+ (void)TF_progressHUDShow:(NSString*)msg;
@end

NS_ASSUME_NONNULL_END
