//
//  TalkfunSettingsCell.m
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2021/11/10.
//  Copyright © 2021 Talkfun. All rights reserved.
//

#import "TalkfunSettingsCell.h"
@interface TalkfunSettingsCell ()

@property(nonatomic,strong)UIView *underline;
@end
@implementation TalkfunSettingsCell



-(instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
      
        self.arrowImageView = [[UIImageView alloc]init];
        self.arrowImageView.image = [UIImage imageNamed:@"behaviorRight"];
        [self.contentView addSubview:self.arrowImageView];
        self.arrowImageView.contentMode = UIViewContentModeScaleAspectFit;
        
        self.underline = [[UIView alloc] init];
        [self.contentView addSubview:self.underline];
        self.underline.backgroundColor = [UIColor colorWithRed:229/255.0 green:229/255.0 blue:229/255.0 alpha:1.0];

    }
    return  self;
}

-(void)layoutSubviews
{
    [super layoutSubviews];
    CGFloat arrowImageViewH = 25;
    CGFloat arrowImageViewW = arrowImageViewH;
    CGFloat arrowImageViewY = (self.frame.size.height - arrowImageViewH)/2;
    self.arrowImageView.frame = CGRectMake(self.width - arrowImageViewW -10, arrowImageViewY, arrowImageViewW, arrowImageViewH);
    
    
    self.underline.frame = CGRectMake(0, self.frame.size.height-0.5, self.width, 0.5);
}

@end
