//
//  TalkfunListPartnerCell.m
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2020/7/24.
//  Copyright © 2020 Talkfun. All rights reserved.
//

#import "TalkfunListPartnerCell.h"

@implementation TalkfunListPartnerCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

-(instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
   self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        self.partnerLab = [[UILabel alloc]init];
        
        self.partnerLab.font = [UIFont fontWithName:@"PingFang SC" size: 16];
        self.partnerLab.textColor = [UIColor colorWithRed:89/255.0 green:93/255.0 blue:96/255.0 alpha:1.0];
        [self.contentView addSubview:self.partnerLab];
        
        self.deleteBtn = [[TalkfunIncreaseButton alloc]init];
       
        
        [self.deleteBtn setImage:[UIImage imageNamed:@"deleteBtn"] forState:UIControlStateNormal];
        [self.deleteBtn setImage:[UIImage imageNamed:@"deleteBtn"] forState:UIControlStateSelected];
        [self.contentView addSubview:self.deleteBtn];
        
    }
    
    return self;
    
}



-(void)layoutSubviews
{
    [super layoutSubviews];
     self.partnerLab.frame = CGRectMake(15, 12, 200, 20);
     self.deleteBtn.frame = CGRectMake(self.widths-35, 12, 20, 20);
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
